#include <bits/stdc++.h>

using namespace std;

const int maxn = 1000005;

int n;

vector<int> g[maxn];
bool visited[maxn];

int parent[maxn];

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n;

    int startU = -1;
    int endV = -1;

    for (int i = 1; i <= n; ++i) {
        int u, v; cin >> u >> v;

        if (startU == -1) {
            startU = u;
        }

        if (i == n) {
            endV = v;
        }

        g[u].push_back(v);
        g[v].push_back(u);
    }

    queue<int> q;
    q.push(startU);

    visited[startU] = true;
    parent[startU] = -1;

    while (!q.empty()) {
        int node = q.front();

        q.pop();

        for (auto v : g[node]) {
            if (!visited[v]) {
                q.push(v);
                visited[v] = true;
                parent[v] = node;
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        if (!visited[i]) {
            cout << "NO" << endl;
            return 0;
        }
    }

    int node = endV;

    vector<int> path;

    while (true) {
        path.push_back(node);
        if (parent[node] == -1) break;
        node = parent[node];
    }

    reverse(path.begin(), path.end());

    cout << "YES\n";

    for (auto x : path) cout << x << " "; cout << endl;

    return 0;
}
