#include <iostream>
#include <cmath>

using namespace std;

int A[1000000];
int B[1000000];
int N, M, C;

int optimal_slow(int Q)
{
    int minimum = 1e+8;
    int Ci = 0;
    for (int i = 0; i < N; i++)
    {
        Ci = B[i] + C * abs(A[i] - Q);
        minimum = min(minimum, Ci);
    }

    return minimum;
}

int main()
{
    int Q;
    cin >> N >> M >> C;

    for (int i = 0; i < N; i++)
    {
        cin >> A[i]; cin >> B[i];
    }

    for (int i = 0; i < Q; i++)
    {
        cin >> Q;
        cout << optimal_slow(Q) << endl;
    }
}
