#include <iostream>
#include <cmath>

using namespace std;

long long A[1000000];
long long B[1000000];
long long N, M, C;

long long optimal_slow(long long Q)
{
    long long minimum = 1e+17;
    long long Ci = 0;
    for (long long i = 0; i < N; i++)
    {
        Ci = B[i] + C * abs(A[i] - Q);
        minimum = min(minimum, Ci);
    }

    return minimum;
}

int main()
{
    long long Q;
    cin >> N >> M >> C;

    for (long long i = 0; i < N; i++)
    {
        cin >> A[i]; cin >> B[i];
    }

    for (long long i = 0; i < M; i++)
    {
        cin >> Q;
        cout << optimal_slow(Q) << endl;
    }
}
