#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1;
int N;
int clothes[MAX_N];
pair<int, int> intervals[MAX_N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N;

    for(int i=1; i<=N; i++)
    {
        cin >> intervals[i].first >> intervals[i].second;
        clothes[i]=i;
    }

    bool is_good=true;

    do
    {
        is_good=true;

        for(int j=1; j<=N; j++)
        {
            if(intervals[clothes[j]].first>j || intervals[clothes[j]].second<j)
            {
                is_good=false;
                break;
            }
        }

        if(is_good)
        {
            break;
        }
    }
    while(next_permutation(clothes, clothes+N+1));

    if(!is_good)
    {
        cout << "NO" << '\n';
    }
    else
    {
        cout << "YES" << '\n';

        for(int i=1; i<=N; i++)
        {
            cout << clothes[i] << " ";
        }
    }
    return 0;
}

