#include <bits/stdc++.h>

using namespace std;

const int N_max = 1e6 + 1;

int l[N_max], r[N_max];
bool used[N_max];

void solve(vector <int> &v, int idx, int N)
{
    if (v.size() == N && idx - 1 == N)
    {
        cout << "YES" << endl;

        for (int i = 0; i < v.size(); i++)
        {
            cout << v[i] << " ";
        }

        cout << endl;

        exit(0);
    }

    for (int i = l[idx]; i <= r[idx]; i++)
    {
        if (!used[i])
        {
            used[i] = 1;
            v.push_back(i);

            solve(v, idx + 1, N);

            used[i] = 0;
            v.pop_back();
        }
    }

    return;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    int N;
    vector <int> v;

    cin >> N;

    for (int i = 1; i <= N; i++)
    {
        cin >> l[i] >> r[i];
    }

    solve(v, 1, N);

    cout << "NO" << endl;

    return 0;
}
