#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, q;

int a[maxn];

struct Query {
    int l;
    int r;
    int d;
    int idx;
};
Query queries[maxn];

vector<int> byValueArray[maxn];
vector<tuple<int, int, int>> byValueQueries[maxn];

int answer[maxn];

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> q;

    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        byValueArray[a[i]].push_back(i);
    }

    for (int i = 1; i <= q; ++i) {
        cin >> queries[i].l >> queries[i].r >> queries[i].d;
        queries[i].idx = i;

        byValueQueries[queries[i].d].push_back(make_tuple(queries[i].l, queries[i].r, i));
    }

    for (int i = 1; i <= n; ++i) {
        for (int d = 1; d * d <= a[i]; ++d) {
            if (a[i] % d == 0) {
                for (auto element : byValueQueries[d]) {
                    if (get<0>(element) <= i && i <= get<1>(element)) answer[get<2>(element)]++;
                }

                int d1 = a[i] / d;

                if (d1 != d) {
                    for (auto element : byValueQueries[d1]) {
                        if (get<0>(element) <= i && i <= get<1>(element)) answer[get<2>(element)]++;
                    }
                }
            }
        }
    }

    for (int i = 1; i <= q; ++i) {
        int x = queries[i].d;

        for (int d = 1; d * d <= x; ++d) {
            if (x % d == 0) {
                for (auto idx : byValueArray[d]) {
                    if (queries[i].l <= idx && idx <= queries[i].r) answer[i]++;
                }

                int d1 = x / d;

                if (d1 != d && d != 1) {
                    for (auto idx : byValueArray[d1]) {
                        if (queries[i].l <= idx && idx <= queries[i].r) answer[i]++;
                    }
                }
            }
        }
    }

    for (int i = 1; i <= q; ++i) cout << answer[i] << " "; cout << endl;

    return 0;
}
