#include<iostream>
#include<vector>
using namespace std;

void DaiMuSkorost(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

vector<vector<int> > reshe;

void simulirai_reshe(int n){

    reshe.resize(n);
    for(int i = 2; i <= (n / 2) + 1; i++){
        reshe[i].push_back(i);
        for(int j = i * 2; j < n; j += i){
            reshe[j].push_back(i);
        }
    }

}

int n, q;
int a[100024];

int bin(int i, int del){
    int l = 0;
    int r = reshe[a[i]].size();
    while(r >= l){
        int mid = (l + r) / 2;
        if(reshe[a[i]][mid] > del) r = mid - 1;
        else l = mid + 1;
    }
    //cout << a[r] << " " << r << " " << del << endl;
    //cout << reshe[a[i]][r] << " " << del << endl;
    return reshe[a[i]][r] == del;
}

int main(){

    DaiMuSkorost();
    simulirai_reshe(210000);


    cin >> n >> q;
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    for(int i = 0; i < q; i++){
        int l, r, ans, otg = 0;
        cin >> l >> r >> ans;
        l--;
        r--;
        for(int j = l; j <= r; j++){
            //cout << ans << " " << a[j] << " " << ans % a[j] << " " << bin(j, ans) << endl;
            if(ans % a[j] == 0 || bin(j, ans)) otg++;
        }
        cout << otg << " ";
    }

    return 0;
}