# include <iostream>
# include <algorithm>
using namespace std;

struct triple
{
     int l,r,id;
};

const int MAX=1e6+111;
triple a[MAX];
int lowest[MAX];
int ans[MAX];

bool cmp(triple a, triple b)
{
    if(a.l<b.l) return true;
    if(b.l<a.l) return false;
    if(a.r<b.r) return true;
    return false;
}

int main()
{
    int n;
    cin>>n;

    for(int i=1; i<=n; i++)
    {
        cin>>a[i].l>>a[i].r;
        a[i].id=i;
    }

    sort(a,a+n+1,cmp);

    for(int i=1;i<=n;i++)
    {
        lowest[i]=1e9+1;
    }

    int p=1,prevp=1,stay=1;
    for(int k=1;k<=n;k++)
    {
        while(a[p].l==k)
        {
            if(a[p].r<lowest[k] and p<=n)
            {
                lowest[k]=a[p].r;
                stay=p;
                p++;
            }
            else break;
        }

        for(int i=prevp;i<=p;i++)
        {
            if(i!=stay and a[i].l+1<=a[i].r) a[i].l++;
        }
        prevp=p;
    }

    sort(a,a+n+1,cmp);

    for(int i=1; i<=n; i++)
    {
        if(a[i].l<=i and i<=a[i].r)
        {
            ans[a[i].id]=i;
        }
        else
        {
            cout<<"NO"<<endl;
            return 0;
        }
    }

    cout<<"YES"<<endl;
    for(int i=1; i<=n; i++)
    {
        cout<<ans[i]<<" ";
    }
    return 0;
}
