#include<bits/stdc++.h>
using namespace std;
#define endl "\n"

const long long MAX_E = 1e5 + 10;

long long brP, brE, gorivoPesh;

pair<long long, long long> eks[MAX_E];

long long val(long long ind, long long x){
    return eks[ind].second + abs(eks[ind].first - x) * gorivoPesh;
}

long long indexFrom(long long ind){
    if(ind < 0) return 0;
    return min(ind, brP - 1);
}

long long finding(long long x){
    long long currInd = brP / 2;
    long long currVal = val(currInd, x);
    long long learnRate = brP / 2;
    while(learnRate >= 1){
        long long nadqsno = indexFrom(currInd + learnRate);
        long long valNadqsno = val(nadqsno, x);
        long long nalqvo = indexFrom(currInd - learnRate);
        long long valNalqvo = val(nalqvo, x);
        learnRate /= 2;
        if(currVal < valNadqsno && currVal < valNalqvo){
            continue;
        }

        if(currVal < valNadqsno && currVal < valNalqvo){
            continue;
        }
        if(valNadqsno < valNalqvo){
            currInd = nadqsno;
            currVal = valNadqsno;
        }else{
            currInd = nalqvo;
            currVal = valNalqvo;
        }
    }
    return currInd;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>brP>>brE>>gorivoPesh;

    for(long long i = 0; i < brP; i++){
        long long a, b;
        cin>>a>>b;

        eks[i] = make_pair(a, b);
    }

    for(long long i = 0; i < brE; i++){
        long long dest;

        cin>>dest;
        long long ind = finding(dest);
        cout<<val(ind, dest)<<endl;
    }


    return 0;
}

