#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_M=1e5+1;
long N, M, C;
pair<long, long> stations[MAX_N];
long expeditions[MAX_N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M >> C;

    for(int i=0; i<N; i++)
    {
        cin >> stations[i].first >> stations[i].second;
    }

    sort(stations, stations+N);

    for(int i=0; i<M; i++)
    {
        cin >> expeditions[i];

        unsigned long long ans;

        for(int j=0; j<N; j++)
        {
            unsigned long long curr=stations[j].second+abs(expeditions[i]-stations[j].first)*C;

            if(j==0)
            {
                ans=curr;
            }
            else
            {
                ans=min(ans, curr);
            }
        }


        cout << ans << '\n';
    }
    return 0;
}

/*
1 1 1000000000
1000000000 1000000000
1

100000000000000000000
*/
