#include <bits/stdc++.h>
using namespace std;

const int MAX_N=1e5+1, MAX_M=1e5+1;
long N, M, C;
pair<long, long> stations[MAX_N];
long expeditions[MAX_N];

long bs_small(const long& x)
{
    long l=0, r=N-1;
    long ans=-1;

    while(l<=r)
    {
        long m=(l+r)/2;

        if(stations[m].first<=x)
        {
            ans=m;
            l=m+1;
        }
        else
        {
            r=m-1;
        }
    }

    return ans;
}

long bs_big(const long& x)
{
    long l=0, r=N-1;
    long ans=-1;

    while(l<=r)
    {
        long m=(l+r)/2;

        if(stations[m].first>=x)
        {
            ans=m;
            r=m-1;
        }
        else
        {
            l=m+1;
        }
    }

    return ans;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> N >> M >> C;

    for(int i=0; i<N; i++)
    {
        cin >> stations[i].first >> stations[i].second;
    }

    sort(stations, stations+N);

    for(int i=0; i<M; i++)
    {
        cin >> expeditions[i];

        unsigned long long ans=-1;

        long op_one=bs_small(expeditions[i]), op_two=bs_big(expeditions[i]);

        if(op_one!=-1)
        {
            ans=stations[op_one].second+abs(expeditions[i]-stations[op_one].first)*C;
        }

        if(op_two!=-1)
        {
            if(ans==-1)
            {
                ans=stations[op_two].second+(expeditions[i]-stations[op_two].first)*C;
            }
            else
            {
                unsigned long long op=stations[op_two].second+(stations[op_two].first-expeditions[i])*C;
                ans=min(ans, op);
            }
        }

        cout << ans << '\n';
    }
    return 0;
}
