#include <bits/stdc++.h>

using namespace std;

const int N_max = 1e6 + 1;

struct triple
{
    int l, r, br, ind;
};

triple in[N_max];
bool used[N_max];
int ans[N_max];

bool cmp(triple &a, triple &b)
{
    if (a.br != b.br)
    {
        return a.br > b.br;
    }

    return a.l < b.l;
}

void solve(vector <int> &v, int idx, int N)
{
    if (v.size() == N && idx - 1 == N)
    {
        cout << "YES" << endl;

        for (int i = 1; i <= N; i++)
        {
            cout << ans[i] << " ";
        }

        cout << endl;

        exit(0);
    }

    for (int i = in[idx].l; i <= in[idx].r; i++)
    {
        if (!used[i])
        {
            used[i] = 1;
            v.push_back(i);
            ans[in[idx].ind] = i;

            solve(v, idx + 1, N);

            used[i] = 0;
            v.pop_back();
            ans[in[idx].ind] = 0;
        }
    }

    return;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);

    int N;
    vector <int> v;

    cin >> N;

    for (int i = 1; i <= N; i++)
    {
        cin >> in[i].l >> in[i].r;

        in[i].br = in[i].r - in[i].l;
        in[i].ind = i;
    }

    sort(in + 1, in + N + 1, cmp);

    solve(v, 1, N);

    cout << "NO" << endl;

    return 0;
}
